<template>
    <!-- details -->
    <div v-if="showDetails" >
      <div class="mt-1">
        <div class="text-left cursor-p mb-3" @click="showDetails = false">
          <i class="fa fa-arrow-left mr-1"> Retour</i>
        </div>
        <div class="d-flex align-items-start ">

          <!-- pictures -->
          <div class="col-6 mx-auto w-100 mb-5" style="height:500px; ">
            <carousel :per-page="1" :speed="1200" :mouse-drag="true" :navigationEnabled="true" 
              :autoplay="true" :centerMode="true" :paginationEnabled="false" 
              :loop="true" :autoplayHoverPause="true" :adjustableHeight="true" 
              :autoplayTimeout="5000">
              <slide v-for="(pic, i) in currentLocation.pictures" :key="i" class="exemple-slide">
                <!-- <div class="produit-photo" :style="'background-image: url(' + pic +')'"></div> -->
                <img class="location-pic img-fluid" :src='pic'>      
              </slide>
            </carousel>
          </div>
          <!-- 
          <div class="carousel-wrapper">
            <div class="carousel-container">
              <div class="carousel">
                <div class="image-one"></div>
                <div class="image-two"></div>
                <div class="image-three"></div>
                <div class="img-fluid" v-for="(pic, i) in currentLocation.pictures" :key="i"
                  :style="'background-image: url(' + pic + ')'"></div> 
                <img v-for="(pic, i) in currentLocation.pictures" :key="i"
                      class="img-fluid" alt="Responsive image" :src="pic" style="height: 100%;width: 100%" >
              </div>
            </div>
          </div>
          -->
          
          <!-- infos -->
          <div class="col-6 mt-5 h-100" >
            <div class="d-flex justify-content-between"> 
              <div>
                <strong> <h3 class="color-win">{{currentLocation.zone}}</h3> </strong>
              </div>
              <div class="text-right" v-if="moreDetails">
                Agence <strong> <h3 class="color-win">{{currentLocation.agence.name}}</h3> {{currentLocation.agence.phone}} </strong>
              </div>
            </div>
            <div class="d-flex align-items-start"> <strong><h2>{{currentLocation.price}}</h2></strong> F CFA</div>
            <div>
              {{currentLocation.message}}
            </div> 
            <div v-if="!moreDetails" class="d-flex align-items-end pull-right">
              <div class="form-group ">
                <input type="submit" @click="showMoreDetails()"
                  class="btn btn-light btn-block"
                  value="Plus de détails"/>
              </div>
            </div>
          </div>
        </div>

      </div>
      <!--  <h1 class="ml-4 mt-5 color-win">Informations Supplémentaires</h1>  -->
      <div class="row mt-3">
        <div v-if="currentLocation.description.superficie && moreDetails" class="col-3 box-style border-style ">
          <div>  Superficie </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.superficie}}<small> m2</small></h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.nbreMenages && moreDetails" class="col-3 box-style border-style">
          <div>  Nombre de Ménages </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.nbreMenages}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.typeCompteur" class="col-3 box-style border-style">
          <div>  Compteur Courant </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.typeCompteur}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.eau" class="col-3 box-style border-style">
          <div>  Source Eau </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.eau}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.genreLocation && moreDetails" class="col-3 box-style border-style">
          <div>  Type Location </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.genreLocation}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.nbreChambres" class="col-3 box-style border-style">
          <div>  Nombre Chambres </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.nbreChambres}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.nbreSalons" class="col-3 box-style border-style">
          <div>  Nombre Salons </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.nbreSalons}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.sanitaire  && moreDetails" class="col-3 box-style border-style">
          <div> Sanitaire </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.sanitaire ? 'OUI' : 'NON'}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.nbreDouches && moreDetails" class="col-3 box-style border-style">
          <div> Douche(s) </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.nbreDouches}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.couloir && moreDetails" class="col-3 box-style border-style">
          <div>  Couloir </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.couloir ? 'OUI' : 'NON'}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.aeration && moreDetails" class="col-3 box-style border-style">
          <div>  Aération </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.aeration}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.garage && moreDetails" class="col-3 box-style border-style">
          <div> Garage </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.garage ? 'OUI' : 'NON'}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.cuisineInterne && currentLocation.description.nbreCuisines && moreDetails" 
          class="col-3 box-style border-style">
          <div>  Cuisine Interne </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.cuisineInterne ? 'OUI' : 'NON'}},
              {{currentLocation.description.nbreCuisines}} Cuisine(s)</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.nouvelleConstruction && moreDetails" class="col-3 box-style border-style">
          <div>  Nouvelle Construction </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.nouvelleConstruction ? 'OUI' : 'NON'}}</h3>
          </div> 
        </div>
        <div v-if="currentLocation.description.arriereCour && moreDetails" class="col-3 box-style border-style">
          <div>  Arrière Cour </div>
          <div class="pull-right">
            <h3 class="card-title">{{currentLocation.description.arriereCour ? 'OUI' : 'NON'}}</h3>
          </div> 
        </div>
      </div>
    </div>
    <!-- local home -->
    <div v-else>
      <!-- search bar -->
      <div class="d-flex align-items-center">
        <div class="form-group col-8 ">
          <input
            class="form-control pr-4"
            @keyup.enter="init(0, true)"
            type="search"
            placeholder=" Zone de recherche"
            v-model="searchtext"  />
        </div>
        <div class="form-group col-4 ">
          <!-- 
          <div class="dropdown">
            <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
              Dropdown button
            </button>
            <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
              <a class="dropdown-item" href="#">Action</a>
              <a class="dropdown-item" href="#">Another action</a>
              <a class="dropdown-item" href="#">Something else here</a>
            </div>
          </div>

           -->
          
          <input  @click="findNearest()"
            class="btn btn-light btn-block"
            value="Rechercher autour de moi"/>
          
        
        
        
        
        </div>
      </div>
      <!-- show -->
      <div class="d-flex flex-row align-items-center" >
        <!-- list -->
        <div class="col-5 d-flex justify-content-center mb-5">
          <div v-if="isLoading">
            <div class="p-5" v-if="isLoading">
              <fulfilling-bouncing-circle-spinner
                class="mx-auto"
                :animation-duration="2000"
                :size="60"
                :color="'#6D071A'"
              />
            </div>
          </div>
          <div v-else class="mb-5">
            <div v-if="total != 0" class="mb-5">
              <div class="d-flex justify-content-around">
                <vue-scroll-snap>
                  <LocationCard
                    v-for="(location, i) in locations"
                    :key="i"
                    :location ="location"
                    :editLocation="() => {editLocation(location)}"
                    :showLocation="() => {showLocation(location)}"
                    :removeLocation="() => {removeLocation(location._id)}"
                  />
                </vue-scroll-snap>
              </div>
            </div>
            <div v-else>
              <h3 class="text-center">Aucune location disponible</h3>
            </div>
          </div>
        </div>
        <!-- maps -->
        <div class="col-7 mb-5" style="height:700px;">
          <!--  <l-map ref="myMap" @ready="doSomethingOnReady()"></l-map>  -->
          <div id="mapid"></div>
        </div>
      </div>
    </div>
</template>

<script>
import L from 'leaflet';
import { LMap, LTileLayer, LMarker } from 'vue2-leaflet';

export default {
  name: 'GoogleMap',
  components: {
    LMap,
    LTileLayer,
    LMarker,
  },
  data() {
    return {
      searchtext: "",
      searchtype: "zone",
      isLoading: false,
      showDetails: false,
      moreDetails: false,
      curPage: 1,
      perPage: 100,
      sort: {},
      locations: null,
      currentLocation: {},
      total: 0,
      center: {
        latitude: 0,
        longitude:0,
      },

      markers: [],
      currentLocations: [],
      distances: [],
      rayon: 7, //en
      mymap : null,
    }
  },
  mounted() {
    this.init();
    //getlocation
    navigator.geolocation.getCurrentPosition(position => {
      //console.log("current location: ", position.coords.latitude,position.coords.longitude,)
      this.center.latitude = position.coords.latitude;
      this.center.longitude = position.coords.longitude;
    });
    if(localStorage.getItem('token'))
      this.moreDetails = true;
    //init the map
    this.mymap = L.map('mapid').setView([6.3702928,2.3912362], 12);  //6.3702928, 2.3912362 
    var osmLayer = L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
        attribution: '© CFA Location',
        maxZoom: 19
    });
    this.mymap.addLayer(osmLayer);
  },
  methods: {
    init(page, resetParams) {
      if (resetParams) {
        this.curPage = 1;
      }
      let query = {
        options: {},
        filter: {
          text: this.searchtext,
          type: this.searchtype.split("+"),
        },
        sort: this.sort,
        page: this.curPage - 1,
        perPage: this.perPage,
      };

      this.isLoading = true;
      this.$service.list("locations", query, (err, data) => {
        if (err) { return console.log(err); }
        this.errorMessage = "";
        this.locations = data.locations;
        this.total = data.locations.length;
        this.isLoading = false;
        this.loadMarkers();
      });
    },
    findNearest(){
      for(let i = 0; i < this.markers.length; i++){
        this.mymap.removeLayer(this.markers[i]);
      }
      this.currentLocations = [];
      /*
      let customIcon = L.icon({
        iconUrl: 'marker.png',
        iconSize: [18, 20],  
      }); */
      for(let i=0;i<this.distances.length;i++){
        //console.log(this.distances[i].value,this.rayon)
        if(this.distances[i].value <= parseFloat(this.rayon)){
          let loc = this.locations[this.distances[i].index]          
          console.log('location find', loc);
          this.currentLocations.push(loc);
        }
      }
      this.locations = this.currentlocations;
      console.log('currentLocations: ',this.currentLocations);
      //console.log('locations: ',this.locations);
      this.loadMarkers(true);
    },
    loadMarkers(status){
      this.distances = [];
      if(!status){
        for(let i=0;i<this.locations.length;i++){
          let loc = this.locations[i];
          let point = {
            longitude : loc.address.longitude,
            latitude : loc.address.latitude
          };
          let marker = L.marker([loc.address.latitude,loc.address.longitude]).addTo(this.mymap);
          marker.bindPopup('<b>'+ this.locations[i].price +' F</b> ,'+ this.locations[i].zone );
          this.distances.push( {index : i,value : this.Equirectangular(this.center, point)  });
          this.markers.push(marker);
        }
        //sort list of distances
        this.distances.sort(function(a, b) {
            return parseFloat(a.value) - parseFloat(b.value);
        })
        console.log(this.distances)
      }else{
        this.locations = this.currentLocations;

        for(let i=0;i<this.currentLocations.length;i++){
          let loc = this.currentLocations[i];
          let point = {
            longitude : loc.address.longitude,
            latitude : loc.address.latitude
          };
          let marker = L.marker([loc.address.latitude,loc.address.longitude]).addTo(this.mymap);
          marker.bindPopup('<b>'+ this.currentLocations[i].price +' F</b> ,'+ this.currentLocations[i].zone );
          this.distances.push( {index : i,value : this.Equirectangular(this.center, point)  });
          this.markers.push(marker);
        }
        //sort list of distances
        this.distances.sort(function(a, b) {
            return parseFloat(a.value) - parseFloat(b.value);
        })
        console.log(this.distances)
      }
    },
    Equirectangular(point1, point2) {
        //console.log(point1,point2)
        var R = 6371; // earth radius in km
        var x = (this.toRad(point2.longitude)-this.toRad(point1.longitude)) *
                Math.cos((this.toRad(point1.latitude)+this.toRad(point2.latitude))/2);
        var y = (this.toRad(point2.latitude)-this.toRad(point1.latitude));
        return Math.sqrt(x*x + y*y) * R;
    },
    toRad (value) {
        //console.log(  value * Math.PI / 180);
        return value * Math.PI / 180;
    },

    doSomethingOnReady(){
        this.map = this.$refs.myMap.mapObject
        //console.log('hellllooo')
    },
    showLocation(location){
      var host = window.location.protocol + "//" + window.location.host;
      //console.log(host);
      
      let datas = {
        admin : '',
        location: location._id, 

        message: '',
        date: new Date(),
        position : this.center,
      }
      if(localStorage.getItem("token")){
        //user already log
        datas.admin = localStorage.getItem("adminId");
        datas.message = 'location details '
      }else{
        //user no log
        datas.admin = host;
        datas.message = 'location details'
      };
      this.$service.createWithoutAuth("historiques", datas, (err, data) => {
        if (err) {
          this.errorMessage = err.data && err.data.message;
          return;
        }
        console.log("ok location details")
        this.showDetails = true;
        this.currentLocation = location;  
        //console.log("currentLocation: ", this.currentLocation);
      });
    },
    showMoreDetails(){
      if(localStorage.getItem("token")){
        //user already log
        let datas = {
          admin : localStorage.getItem("adminId"),
          location: this.currentLocation._id, 

          message: 'location more details',
          date: new Date(),
          position : this.center,
        };
        //console.log("datasssss: ",datas)
        this.$service.create("historiques", datas, (err, data) => {
          if (err) {
            this.errorMessage = err.data && err.data.message;
            return;
          }
          console.log("ok location more details")
          this.moreDetails = true;  
        });
      }else{
        //user no log
        this.$swal.fire("Veuillez vous connecter pour accéder aux détails !!!", "","warning").then(() => {
          this.$router.push({ path: "/register" });
        });
      }
    },
    removeLocation(id) {
      this.$swal
      .fire({
        title: "Voulez-vous vraiment supprimer?",
        text: "Vous ne pouvez plus récuperer ces données !",
        icon: "warning",
        showCancelButton: true,
        cancelButtonColor: "#3085d6",
        confirmButtonColor: "#d33",
        confirmButtonText: "Oui, supprimer!",
      })
      .then((result) => {
        if (result.value) {
          this.$service.remove("locations", id, (err, data) => {
            if (err) {
              this.errorMessage = err.data && err.data.message;
              console.log("Error", err.data);
              return;
            }

            let datas = {
              admin : localStorage.getItem("adminId"),

              message: 'remove location',
              date: new Date(),
              position : this.center,
            };
            this.$service.create("historiques", datas, (err, data) => {
              if (err) {
                this.errorMessage = err.data && err.data.message;
                return;
              }
              this.$swal
              .fire( "Suppression réussie", "La suppression s'est effectuée avec succès", "success" )
              .then(() => { this.init(); }); 
            });
          });
        }
      });
    },
  }
}
</script>


<style lang="scss" scoped>

#mapid { height: 600px; }

.color-win {
  color: #6D071A;
}
.border-style{
  border: #6D071A 2px solid;
  border-radius: 10px;
}
.box-style{
  height: 100px;
  //margin: 1px ;
}


.location-pic {
  position: relative;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  padding-left: 3px;   
  padding-right: 3px;   
  margin-right: auto;   
  width: 100%;
  background-color: #efefef; /*#A2A2A2;*/
  border-bottom: 1px solid rgb(23, 25, 29);
  border-top-left-radius: 8px; 
  border-top-right-radius: 8px; 
  /* cursor: pointer; */
  background-size: cover;
}



.item {
  /* Set the minimum height of the items to be the same as the height of the scroll-snap-container.*/
  min-height: 500px;
}

.scroll-snap-container {
  height: 600px;
  width: 450px;
}


$size-width: 650px;
$size-height: 450px;

.carousel-wrapper {
  width: $size-width * 1.3;
  height: $size-height * 1.1;
  display: flex;
  justify-content: center;
  align-items: center;
  box-shadow: 5px 5px 25px 0px rgba(46, 61, 73, 0.2);
  border-radius: 20px;
  margin: 20px auto ;
}

.carousel-container {
  width: $size-width;
  height: $size-height;
  overflow: hidden;
  margin: 0 auto;
}

.carousel {
  display: flex;
  width: $size-width * 4;
  animation: sliding 12s infinite;
  div {
    width: $size-width;
    height: $size-height;
    background-size: cover;
    background-position: center;
  }
  &:hover {
    animation-play-state: paused;
  }
  
  .image-one {
    background-image: url("https://images.unsplash.com/photo-1480936600919-bffa6b7ecf1e?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=crop&w=500&q=60");
  }
  .image-two {
    background-image: url("https://images.unsplash.com/photo-1475053081036-c8eb31d187b3?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=crop&w=500&q=60");
  }
  .image-three {
    background-image: url("https://images.unsplash.com/photo-1525278070609-779c7adb7b71?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=crop&w=500&q=60");
  }
  
}

@keyframes sliding {
  30% {
    transform: translateX(0);
  }
  35% {
    transform: translateX(-$size-width);
  }
  65% {
    transform: translateX(-$size-width);
  }
  70% {
    transform: translateX(-$size-width * 2);
  }
  98% {
    transform: translateX(-$size-width * 2);
  }
  100% {
    transform: translateX(0);
  }
}

@media screen and (max-width: 768px) {
  $size-width: 240px;
  $size-height: 150px;
  .carousel-wrapper {
    width: $size-width * 1.3;
    height: $size-height * 1.4;
  }

  .carousel-container {
    width: $size-width;
    height: $size-height;
  }

  .carousel {
    width: $size-width * 3;
    > div {
      width: $size-width;
      height: $size-height;
    }
  }

  @keyframes sliding {
    30% {
      transform: translateX(0);
    }
    35% {
      transform: translateX(-$size-width);
    }
    65% {
      transform: translateX(-$size-width);
    }
    70% {
      transform: translateX(-$size-width * 2);
    }
    98% {
      transform: translateX(-$size-width * 2);
    }
    100% {
      transform: translateX(0);
    }
  }
}
</style>
